"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// meta.ts
var meta_exports = {};
__export(meta_exports, {
  getMeteredBillingCharges: () => getMeteredBillingCharges2,
  getPurchaseHistory: () => getPurchaseHistory2,
  getUrl: () => getUrl2
});
module.exports = __toCommonJS(meta_exports);

// src/devcenter-checkout-v1-purchased-item-billing.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressMarketAimApiCheckoutUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/app-instance-manager-webapp",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "dev._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      },
      {
        srcPath: "/api/v1/instance",
        destPath: "/v1/instance"
      },
      {
        srcPath: "/api/v1/scripts",
        destPath: "/v1/scripts"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_app-management_billing";
function getUrl(payload) {
  function __getUrl({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [{ path: "chargeOverride.price" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "POST",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetUrl",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/checkout",
        data: serializedData,
        host
      }),
      data: serializedData
    };
    return metadata;
  }
  return __getUrl;
}
function getPurchaseHistory(payload) {
  function __getPurchaseHistory({ host }) {
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetPurchaseHistory",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/checkout/history",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "purchases.dateCreated" }]
        }
      ])
    };
    return metadata;
  }
  return __getPurchaseHistory;
}
function getMeteredBillingCharges(payload) {
  function __getMeteredBillingCharges({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "startDate" }, { path: "endDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetMeteredBillingCharges",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/metered-billing-charges",
        data: serializedData,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(serializedData)
    };
    return metadata;
  }
  return __getMeteredBillingCharges;
}

// src/devcenter-checkout-v1-purchased-item-billing.meta.ts
function getUrl2() {
  const payload = {};
  const getRequestOptions = getUrl(payload);
  const getUrl3 = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl: getUrl3,
    httpMethod: "POST",
    path: "/v1/checkout",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getPurchaseHistory2() {
  const payload = {};
  const getRequestOptions = getPurchaseHistory(payload);
  const getUrl3 = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl: getUrl3,
    httpMethod: "GET",
    path: "/v1/checkout/history",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getMeteredBillingCharges2() {
  const payload = {};
  const getRequestOptions = getMeteredBillingCharges(
    payload
  );
  const getUrl3 = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl: getUrl3,
    httpMethod: "GET",
    path: "/v1/metered-billing-charges",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getMeteredBillingCharges,
  getPurchaseHistory,
  getUrl
});
//# sourceMappingURL=meta.js.map