// src/devcenter-checkout-v1-purchased-item-billing.public.ts
import { renameKeysFromRESTResponseToSDKResponse as renameKeysFromRESTResponseToSDKResponse2 } from "@wix/sdk-runtime/rename-all-nested-keys";
import { EventDefinition } from "@wix/sdk-types";

// src/devcenter-checkout-v1-purchased-item-billing.universal.ts
import { transformError as sdkTransformError } from "@wix/sdk-runtime/transform-error";
import {
  renameKeysFromSDKRequestToRESTRequest,
  renameKeysFromRESTResponseToSDKResponse
} from "@wix/sdk-runtime/rename-all-nested-keys";

// src/devcenter-checkout-v1-purchased-item-billing.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformSDKFloatToRESTFloat } from "@wix/sdk-runtime/transformations/float";
import { transformSDKTimestampToRESTTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressMarketAimApiCheckoutUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/app-instance-manager-webapp",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "dev._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      },
      {
        srcPath: "/api/v1/instance",
        destPath: "/v1/instance"
      },
      {
        srcPath: "/api/v1/scripts",
        destPath: "/v1/scripts"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_app-management_billing";
function getUrl(payload) {
  function __getUrl({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKFloatToRESTFloat,
        paths: [{ path: "chargeOverride.price" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "POST",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetUrl",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/checkout",
        data: serializedData,
        host
      }),
      data: serializedData
    };
    return metadata;
  }
  return __getUrl;
}
function getPurchaseHistory(payload) {
  function __getPurchaseHistory({ host }) {
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetPurchaseHistory",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/checkout/history",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "purchases.dateCreated" }]
        }
      ])
    };
    return metadata;
  }
  return __getPurchaseHistory;
}
function getMeteredBillingCharges(payload) {
  function __getMeteredBillingCharges({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "startDate" }, { path: "endDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetMeteredBillingCharges",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/metered-billing-charges",
        data: serializedData,
        host
      }),
      params: toURLSearchParams(serializedData)
    };
    return metadata;
  }
  return __getMeteredBillingCharges;
}

// src/devcenter-checkout-v1-purchased-item-billing.universal.ts
var PaymentCycle = /* @__PURE__ */ ((PaymentCycle2) => {
  PaymentCycle2["NO_CYCLE"] = "NO_CYCLE";
  PaymentCycle2["MONTHLY"] = "MONTHLY";
  PaymentCycle2["YEARLY"] = "YEARLY";
  PaymentCycle2["ONE_TIME"] = "ONE_TIME";
  PaymentCycle2["TWO_YEARS"] = "TWO_YEARS";
  PaymentCycle2["THREE_YEARS"] = "THREE_YEARS";
  PaymentCycle2["FOUR_YEARS"] = "FOUR_YEARS";
  PaymentCycle2["FIVE_YEARS"] = "FIVE_YEARS";
  return PaymentCycle2;
})(PaymentCycle || {});
var InvoiceStatus = /* @__PURE__ */ ((InvoiceStatus2) => {
  InvoiceStatus2["UNKNOWN_INVOICE_STATUS"] = "UNKNOWN_INVOICE_STATUS";
  InvoiceStatus2["PAYMENT_FAILED"] = "PAYMENT_FAILED";
  InvoiceStatus2["PAID"] = "PAID";
  InvoiceStatus2["REFUNDED"] = "REFUNDED";
  InvoiceStatus2["VOIDED"] = "VOIDED";
  InvoiceStatus2["CHARGEDBACK"] = "CHARGEDBACK";
  return InvoiceStatus2;
})(InvoiceStatus || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function getUrl2(productId, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = renameKeysFromSDKRequestToRESTRequest({
    productId,
    successUrl: options?.successUrl,
    testCheckout: options?.testCheckout,
    billingCycle: options?.billingCycle,
    countryCode: options?.countryCode,
    languageCode: options?.languageCode,
    couponCode: options?.couponCode
  });
  const reqOpts = getUrl(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          productId: "$[0]",
          successUrl: "$[1].successUrl",
          testCheckout: "$[1].testCheckout",
          billingCycle: "$[1].billingCycle",
          countryCode: "$[1].countryCode",
          languageCode: "$[1].languageCode",
          couponCode: "$[1].couponCode"
        },
        singleArgumentUnchanged: false
      },
      ["productId", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getPurchaseHistory2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = renameKeysFromSDKRequestToRESTRequest({});
  const reqOpts = getPurchaseHistory(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getMeteredBillingCharges2(options) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = renameKeysFromSDKRequestToRESTRequest({
    currency: options?.currency,
    startDate: options?.startDate,
    endDate: options?.endDate
  });
  const reqOpts = getMeteredBillingCharges(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          currency: "$[0].currency",
          startDate: "$[0].startDate",
          endDate: "$[0].endDate"
        },
        singleArgumentUnchanged: false
      },
      ["options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/devcenter-checkout-v1-purchased-item-billing.public.ts
function getUrl3(httpClient) {
  return (productId, options) => getUrl2(
    productId,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function getPurchaseHistory3(httpClient) {
  return () => getPurchaseHistory2(
    // @ts-ignore
    { httpClient }
  );
}
function getMeteredBillingCharges3(httpClient) {
  return (options) => getMeteredBillingCharges2(
    options,
    // @ts-ignore
    { httpClient }
  );
}
var onPurchasedItemInvoiceStatusUpdated = EventDefinition(
  "InvoiceStatusUpdated",
  false,
  (event) => renameKeysFromRESTResponseToSDKResponse2(event)
)();

// src/devcenter-checkout-v1-purchased-item-billing.context.ts
import { createRESTModule } from "@wix/sdk-runtime/rest-modules";
import { createEventModule } from "@wix/sdk-runtime/event-definition-modules";
var getUrl4 = /* @__PURE__ */ createRESTModule(getUrl3);
var getPurchaseHistory4 = /* @__PURE__ */ createRESTModule(getPurchaseHistory3);
var getMeteredBillingCharges4 = /* @__PURE__ */ createRESTModule(getMeteredBillingCharges3);
var onPurchasedItemInvoiceStatusUpdated2 = createEventModule(onPurchasedItemInvoiceStatusUpdated);
export {
  InvoiceStatus,
  PaymentCycle,
  WebhookIdentityType,
  getMeteredBillingCharges4 as getMeteredBillingCharges,
  getPurchaseHistory4 as getPurchaseHistory,
  getUrl4 as getUrl,
  onPurchasedItemInvoiceStatusUpdated2 as onPurchasedItemInvoiceStatusUpdated
};
//# sourceMappingURL=index.mjs.map