// src/devcenter-checkout-v1-purchased-item-billing.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformSDKFloatToRESTFloat } from "@wix/sdk-runtime/transformations/float";
import { transformSDKTimestampToRESTTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressMarketAimApiCheckoutUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/app-instance-manager-webapp",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "dev._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      },
      {
        srcPath: "/api/v1/instance",
        destPath: "/v1/instance"
      },
      {
        srcPath: "/api/v1/scripts",
        destPath: "/v1/scripts"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_app-management_billing";
function getUrl(payload) {
  function __getUrl({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKFloatToRESTFloat,
        paths: [{ path: "chargeOverride.price" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "POST",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetUrl",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/checkout",
        data: serializedData,
        host
      }),
      data: serializedData
    };
    return metadata;
  }
  return __getUrl;
}
function getPurchaseHistory(payload) {
  function __getPurchaseHistory({ host }) {
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetPurchaseHistory",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/checkout/history",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "purchases.dateCreated" }]
        }
      ])
    };
    return metadata;
  }
  return __getPurchaseHistory;
}
function getMeteredBillingCharges(payload) {
  function __getMeteredBillingCharges({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "startDate" }, { path: "endDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.devcenter.checkout.v1.purchased_item",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.Checkout.GetMeteredBillingCharges",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiCheckoutUrl({
        protoPath: "/v1/metered-billing-charges",
        data: serializedData,
        host
      }),
      params: toURLSearchParams(serializedData)
    };
    return metadata;
  }
  return __getMeteredBillingCharges;
}

// src/devcenter-checkout-v1-purchased-item-billing.meta.ts
function getUrl2() {
  const payload = {};
  const getRequestOptions = getUrl(payload);
  const getUrl3 = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl: getUrl3,
    httpMethod: "POST",
    path: "/v1/checkout",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getPurchaseHistory2() {
  const payload = {};
  const getRequestOptions = getPurchaseHistory(payload);
  const getUrl3 = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl: getUrl3,
    httpMethod: "GET",
    path: "/v1/checkout/history",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getMeteredBillingCharges2() {
  const payload = {};
  const getRequestOptions = getMeteredBillingCharges(
    payload
  );
  const getUrl3 = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl: getUrl3,
    httpMethod: "GET",
    path: "/v1/metered-billing-charges",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
export {
  getMeteredBillingCharges2 as getMeteredBillingCharges,
  getPurchaseHistory2 as getPurchaseHistory,
  getUrl2 as getUrl
};
//# sourceMappingURL=meta.mjs.map